Bug 1255822 - glibc: malloc may fall back to calling mmap prematurely if arenas are contended
glibc: malloc may fall back to calling mmap prematurely if arenas are contended
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: glibc (Show other bugs)
7.3
Unspecified Unspecified
unspecified Severity unspecified
: rc
: ---
Assigned To: Carlos O'Donell
Arjun Shankar
: Patch
Depends On: 1348620
Blocks: 1297579 1313485
  Show dependency treegraph
 
Reported: 2015-08-21 12:00 EDT by Siddhesh Poyarekar
Modified: 2017-01-25 07:00 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Cause: In a low-memory situation, a logic error causes glibc malloc to use mmap even if memory is available internally without requesting it from the kernel. Consequence: The malloc implementation in glibc could use excessively rely on mmap, resulting performance problems. Fix: The logic error is corrected and available memory is reused. Result: Application performance in low-memory situations should improve.
Story Points: ---
Clone Of:
: 1348620 (view as bug list)
Environment:
Last Closed: 2016-11-03 04:25:03 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
glibc-rh1245731-4.patch (1.38 KB, patch)
2016-06-21 11:10 EDT, Florian Weimer
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Sourceware 20284 None None None 2016-06-21 10:49 EDT

  None (edit)
Description Siddhesh Poyarekar 2015-08-21 12:00:41 EDT
Description of problem:
Due to the robust malloc changes, malloc functions may end up calling mmap prematurely if all arenas are contended but not corrupt.  This is not a serious issue in the general case and its performance impact is also questionable because it is not clear if the contention is more expensive in terms of time than a system call.  It is however expensive resource-wise if the block requests are significantly smaller than page size because that will create a lot of external holes.

See also: bug 1246713 for rhel-6, where this problem is one of two problems that the bug report mentioned.
Comment 6 Florian Weimer 2016-06-21 11:10 EDT
Created attachment 1170318 [details]
glibc-rh1245731-4.patch

This is the patch which went into rhel-6.7.z.
Comment 7 Florian Weimer 2016-06-21 11:22:21 EDT
Proposed upstream fix: https://sourceware.org/ml/libc-alpha/2016-06/msg00815.html
Comment 14 errata-xmlrpc 2016-11-03 04:25:03 EDT
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2016-2573.html

Note You need to log in before you can comment on or make changes to this bug.